# - Find OpenSLES
# Find the OpenSLES includes and libraries
#
#  OPENSLES_INCLUDE_DIR - where to find dsound.h
#  OPENSLES_LIBRARIES   - List of libraries when using dsound.
#  OPENSLES_FOUND       - True if dsound found.

get_property(_FIND_LIBRARY_USE_LIB64_PATHS GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS 1)

find_path(OPENSLES_INCLUDE_DIR SLES/OpenSLES.h)

find_library(OPENSLES_LIBRARY NAMES OpenSLES)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(OPENSLES DEFAULT_MSG
	OPENSLES_INCLUDE_DIR OPENSLES_LIBRARY)
						
if(OPENSLES_FOUND)
	set(OPENSLES_INCLUDE_DIRS ${OPENSLES_INCLUDE_DIR})
	set(OPENSLES_LIBRARIES ${OPENSLES_LIBRARY})
else(OPENSLES_FOUND)
	if (OpenSLES_FIND_REQUIRED)
		message(FATAL_ERROR "Could NOT find OPENSLES")
	endif()
endif(OPENSLES_FOUND)

mark_as_advanced(OPENSLES_INCLUDE_DIR OPENSLES_LIBRARY)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS ${_FIND_LIBRARY_USE_LIB64_PATHS})
